package org.mitre.oauth2.model;

import java.util.UUID;

import org.apache.commons.codec.binary.Base64;
import org.mitre.oauth2.model.ClientDetailsEntity.ClientDetailsEntityBuilder;
import org.springframework.stereotype.Service;

/**
 * A factory for making OAuth2 clients with autogenerated IDs and secrets (as desired)
 * @author jricher
 *
 */
@Service
public class ClientGeneratorFactory implements ClientDetailsEntityFactory {

	@Override
	public ClientDetailsEntity createClient(String clientId, String clientSecret) {
		ClientDetailsEntityBuilder builder = ClientDetailsEntity.makeBuilder();
		if (clientId == null) {
			clientId = UUID.randomUUID().toString();
		}
		builder.setClientId(clientId);
		if (clientSecret == null) {
			clientSecret = Base64.encodeBase64((UUID.randomUUID().toString() + UUID.randomUUID().toString()).getBytes()).toString();
		}
		builder.setClientSecret(clientSecret);
		
		return builder.finish();
	}

}
