$(function () {

    module("bootstrap-alerts")

      test("should be defined on jquery object", function () {
        ok($(document.body).alert, 'alert method is defined')
      })

      test("should return element", function () {
        ok($(document.body).alert()[0] == document.body, 'document.body returned')
      })

      test("should fade element out on clicking .close", function () {
        var alertHTML = '<div class="alert-message warning fade in">'
          + '<a class="close" href="#">×</a>'
          + '<p><strong>Holy guacamole!</strong> Best check yo self, you’re not looking too good.</p>'
          + '</div>'
          , alert = $(alertHTML).alert()

        alert.find('.close').click()

        ok(!alert.hasClass('in'), 'remove .in class on .close click')
      })

      test("should remove element when clicking .close", function () {
        $.support.transition = false

        var alertHTML = '<div class="alert-message warning fade in">'
          + '<a class="close" href="#">×</a>'
          + '<p><strong>Holy guacamole!</strong> Best check yo self, you’re not looking too good.</p>'
          + '</div>'
          , alert = $(alertHTML).appendTo('#qunit-runoff').alert()

        ok($('#qunit-runoff').find('.alert-message').length, 'element added to dom')

        alert.find('.close').click()

        ok(!$('#qunit-runoff').find('.alert-message').length, 'element removed from dom')
      })

})